poj 3126 Bfs

Prime Path
Time Limit: 1000MS   Memory Limit: 65536K
Total Submissions: 14539   Accepted: 8196

Description

The ministers of the cabinet were quite upset by the message from the Chief of Security stating that they would all have to change the four-digit room numbers on their offices. 
— It is a matter of security to change such things every now and then, to keep the enemy in the dark. 
— But look, I have chosen my number 1033 for good reasons. I am the Prime minister, you know! 
— I know, so therefore your new number 8179 is also a prime. You will just have to paste four new digits over the four old ones on your office door. 
— No, it’s not that simple. Suppose that I change the first digit to an 8, then the number will read 8033 which is not a prime! 
— I see, being the prime minister you cannot stand having a non-prime number on your door even for a few seconds. 
— Correct! So I must invent a scheme for going from 1033 to 8179 by a path of prime numbers where only one digit is changed from one prime to the next prime.

Now, the minister of finance, who had been eavesdropping, intervened. 
— No unnecessary expenditure, please! I happen to know that the price of a digit is one pound. 
— Hmm, in that case I need a computer program to minimize the cost. You don't know some very cheap software gurus, do you? 
— In fact, I do. You see, there is this programming contest going on... Help the prime minister to find the cheapest prime path between any two given four-digit primes! The first digit must be nonzero, of course. Here is a solution in the case above. 
1033
1733
3733
3739
3779
8779
8179
The cost of this solution is 6 pounds. Note that the digit 1 which got pasted over in step 2 can not be reused in the last step – a new 1 must be purchased.

Input

One line with a positive number: the number of test cases (at most 100). Then for each test case, one line with two numbers separated by a blank. Both numbers are four-digit primes (without leading zeros).

Output

One line for each case, either with a number stating the minimal cost or containing the word Impossible.

Sample Input

3
1033 8179
1373 8017
1033 1033

Sample Output

6
7
0
题意: 输入多组数据,每组数据包括两个四位素数1033 8179,每次只改变四位数中的一位并且改变后的数也为素数,从1033到8179有6部。没有路径则输出Imbossiblei。
做法: 这是一个40端口的bfs不过剪枝之后就没有40入口了,入口数远小于40

               无论是判定素数还是搜索素数,首先排除偶数,这样就剪掉一半枝叶了

               判断素数用根号法判断,

               如果一个数X不能被 [2,√X] 内的所有素数整除,那么它就是素数

               可以判断的复杂度降到logn

               注意:千位的变换要保证千位不为0

               其实素数也是用来辅助搜索剪枝的#include <iostream>#include <stdio.h>

#include <queue>
#include <string.h>
using namespace std;
const int MAX=10000;
int dis[MAX],str[4];
bool vis[MAX];
bool just(int n)
{
    for(int i=2; i*i<=n; i++)
    {
        if(n%i==0)
            return 0;
    }
    return 1;
}
int bfs(int star,int ends)
{
    int y;
    memset(vis,0,sizeof(vis));
    memset(dis,0,sizeof(dis));
    queue<int> q;
    q.push(star);
    vis[star]=1;
    if(star==ends)
        return 0;
    while(!q.empty())
    {
        int x=q.front();
        q.pop();
        str[0]=x/1000;
        str[1]=x/100%10;
        str[2]=x/10%10;
        str[3]=x%10;
        for(int i=0; i<4; i++)
        {
            int h=str[i];//注意这里记住这个str[i];
            if(i==0)
                for(int j=1; j<10; j++)
                {
                    str[i]=j;
                    y=str[0]*1000+str[1]*100+str[2]*10+str[3];
                    if(!vis[y]&&just(y))
                    {
                        q.push(y);
                        vis[y]=1;
                        dis[y]=dis[x]+1;
                        if(y==ends)
                            return dis[y];
                    }
                }
            else
                for(int j=0; j<10; j++)
                {
                    str[i]=j;
                    y=str[0]*1000+str[1]*100+str[2]*10+str[3];
                    if(!vis[y]&&just(y))
                    {
                        q.push(y);
                        vis[y]=1;
                        dis[y]=dis[x]+1;
                        if(y==ends)
                            return dis[y];
                    }
                }
            str[i]=h;//在这里返回去;
} }
return -1; } int main() { int t,star,ends; scanf("%d",&t); getchar(); while(t--) { scanf("%d%d",&star,&ends); int s=bfs(star,ends); if(s!=-1) printf("%d ",s); else printf("Impossible "); } return 0; }
原文地址:https://www.cnblogs.com/yuanbo123/p/4861669.html